#ifndef INC_GTBASE_H
#define INC_GTBASE_H

#include "gttypes.h"
#include "gttags.h"
#include "gttagdefs.h"

/************************************************************************\
*
* GtBase class header.
*
* Superclass for all Gt classes.
*
* $Ident: This file is part of the 'Gt-library' 1.0.0 $
* $Copyright: (C) 1997 by Gran Gustafsson $
*
\************************************************************************/

class GtBase
{
public:
	GtBase(void);
	virtual void Destroy(void);
	virtual void DeInit(void);
	virtual sbool Init(GtTag *tgs)=0;
	virtual sbool Set(GtTag *tgs)=0;
	virtual void Get(GtTag *tgs)=0;
	virtual char *GetClass(void) { return("GtBase"); }
	virtual sbool IsSubClassOf(char *cn);
	virtual void PrtErrHeader(void);
	sbool InitV(ulong tag,...);
	sbool SetV(ulong tag,...);
	void GetV(ulong tag,...);
	long GetA(ulong tag,long def);
		/* External friend */
	friend void GtDestroy(GtBase *obj);
private:
	sbool del;
};

extern void GtDestroy(GtBase *obj);

#endif /* INC_GTBASE_H */
