#include "gtall.h"

GtFont *title;
GtScrollBar *sbh,*sbv;
ulong l=0,x,y;

int QuitCB(GtBase *obj,GtCDPtr cd,GtUDPtr ud)
{
	((GtApp *)ud)->BreakLoop();
	return(GTCB_CONT);
}

int TxtChgCB(GtBase *obj,GtCDPtr cd,GtUDPtr ud)
{
	GtTextViewCD *tcd;
	
	tcd=(GtTextViewCD *)cd;
	sbh->SetV(
		GT_Value,tcd->txtxp,
		GT_End,tcd->txtxs,
		GT_Page,tcd->xsize,
		GT_ReduceInterval,TRUE,
		GT_DONE);
	sbv->SetV(
		GT_Value,tcd->txtyp,
		GT_End,tcd->txtys,
		GT_Page,tcd->ysize,
		GT_DONE);
	x=tcd->txtxp;
	y=tcd->txtyp;
	return(GTCB_CONT);
}

int VertChgCB(GtBase *obj,GtCDPtr cd,GtUDPtr ud)
{
	GtTextView *txt;
	GtScrollerCD *scd;

	scd=(GtScrollerCD *)cd;
	txt=(GtTextView *)ud;
	y=scd->value;
	txt->SetPosition(x,y);
	return(GTCB_CONT);
}

int HorizChgCB(GtBase *obj,GtCDPtr cd,GtUDPtr ud)
{
	GtTextView *txt;
	GtScrollerCD *scd;

	scd=(GtScrollerCD *)cd;
	txt=(GtTextView *)ud;
	x=scd->value;
	txt->SetPosition(x,y);
	return(GTCB_CONT);
}

int DoneCB(GtBase *obj,GtCDPtr cd,GtUDPtr ud)
{
	GtTextView *txt;
	GtSIDoneCD *scd;
	GtFont *f=NULL;
	int p;
	
	scd=(GtSIDoneCD *)cd;
	if(scd->why!=GTDW_MOUSE)
	{
		txt=(GtTextView *)ud;
		if(l==0)
			f=title;
		if((l==0) || (scd->str[0]=='\\'))
			l=txt->AddLine(GTP_LAST);
		p=txt->AddPart(l,strdup(scd->str),scd->len,GTP_LAST);
		txt->SetTextAttr(p,f,0,0,0);
		txt->Refresh();
		((GtStrInput *)obj)->Activate();
	}
	return(GTCB_CONT);
}

int main(int argc,char **argv)
{
	GtApp *app;
	GtAppDisp *dsp;
	GtAppShell *shell;
	GtGroup *g;
	GtStrInput *str;
	GtTextView *txt;
	GtMatrix *m;

	app=GtMkApp(NULL);
	app->SetupRes(&argc,argv);
	dsp=GtMkAppDisp(app,NULL);
	title=GtMkFont(dsp,GT_FontList,"-*-courier-bold-r-*-*-17-*-*-*-*-*-*-*",GT_DONE);
	shell=GtMkAppShell("shell",(GtManager *)dsp,
		GT_DONE);
	shell->AddCB(GT_Close,QuitCB,app);
	g=GtMkGroup("grp",shell,GT_Orient,GTO_VERT,GT_BAll,2,GT_DONE);
	str=GtMkStrInput("str",g,GT_Weight,0,GT_DONE);
	m=GtMkMatrix("mat",g,GT_Columns,2,GT_Rows,2,GT_DONE);
	txt=GtMkTextView("txt",m,NULL);
	str->AddCB(GT_Done,DoneCB,txt);
	txt->AddCB(GT_ValueChange,TxtChgCB,NULL);
	sbv=GtMkScrollBar("sbv",m,
		GT_Orient,GTO_VERT,
		GT_ReportDrag,TRUE,
		GT_ReduceInterval,TRUE,
		GT_DONE);
	sbv->AddCB(GT_ValueChange,VertChgCB,txt);
	sbh=GtMkScrollBar("sbh",m,
		GT_ReportDrag,TRUE,
		GT_ReduceInterval,TRUE,
		GT_DONE);
	sbh->AddCB(GT_ValueChange,HorizChgCB,txt);
	shell->Build();
	app->EventLoop(GTAM_LOOP);
	GtDestroy(app);
}
